/*
  license GPL v3 ...........

  description of this file:
  a page for viewing a user selected RSS feed ;

  Architecture:
  page
  {
    ToolbarActions

    Rectangle
    {
        label(RSS feed title)
    }

    ListView
    {
    }

    Component(delegate)

    XmlListModel(rss feed)
  }
*/

import QtQuick 2.0
import QtQuick.XmlListModel 2.0
import Ubuntu.Components 0.1
import Ubuntu.Components.ListItems 0.1 as ListItem

Page {
    id: page_feed
//    width: 100
//    height: 62
    property string rssmodel_url: ""
    property string rsstitle: ""
    property int rss_index: 0

    onRss_indexChanged:
    {
        rss_listview.currentIndex = rss_index
    }

    tools: ToolbarActions {
        Action {
            text: "action 1"
            iconSource: Qt.resolvedUrl("avatar.png")
        }
        Action {
            text: "action 2"
            iconSource: Qt.resolvedUrl("avatar.png")
        }
    }

//    Rectangle
//    {
//        id: bg
//        anchors.fill: parent
//        color: "white"
//    }

    //////////////////////////////////////////////      shows the RSS feed title
    Rectangle
    {
        id: rec_title
        width: parent.width
        height: label_title.height + units.gu(1)
        color: "orange"

        Label
        {
            id: label_title
            anchors.centerIn: parent
            width: parent.width - units.gu(2)
            wrapMode: Text.WrapAtWordBoundaryOrAnywhere
            text: rsstitle
            color: "white"
        }
    }

    //////////////////////////////////////////////      a listview to show the RSS content
    ListView
    {
        id: rss_listview
        width: parent.width
        anchors.bottom: parent.bottom
        anchors.bottomMargin: units.gu(1)
        anchors.top: rec_title.bottom
        anchors.topMargin: units.gu(2)
        snapMode: ListView.SnapOneItem
//        height: isList ? 0 : units.gu(30)
//        opacity: isList ? 0 : 1
        cacheBuffer: 90
//        spacing: units.gu(2)
        boundsBehavior: Flickable.StopAtBounds
        orientation: ListView.Horizontal
//        currentIndex: rss_index
        contentHeight: parent.width * count
        model: rssmodel
        delegate: xmldelegate
    }

    //////////////////////////////////////////////      delegate for ListView
    Component
    {
        id: xmldelegate

        Column
        {
            spacing: units.gu(2)
            width: rss_listview.width
            height: rss_listview.height

            Label
            {
                fontSize: "large"
                text: model_title
                anchors.horizontalCenter: parent.horizontalCenter
                width: parent.width - units.gu(2)
                wrapMode: Text.WrapAtWordBoundaryOrAnywhere
                color: "black"
            }

            Label
            {
                text:
                {
                    if (description.split("</a>").length > 1)
                        return description.split("</a>")[1].split("</p>")[0] ;
                    else
                        return description ;
                }
                anchors.horizontalCenter: parent.horizontalCenter
                width: parent.width - units.gu(1)
                wrapMode: Text.WrapAtWordBoundaryOrAnywhere
                color: "black"

                MouseArea
                {
                    anchors.fill: parent
                    onClicked:
                    {
                        console.log("current index : " + index) ;
                    }
                }
            }
        }

//        RssItemDelegate
//        {
//            width: units.gu(30)
//            height: rss_listview.height
//            rss_title: title
//            rss_description:
//            {
//                if (description.split("</a>").length > 1)
//                    return description.split("</a>")[1].split("</p>")[0] ;
//                else
//                    return description ;
//            }
//        }
    }

    //////////////////////////////////////////////////       RSS xml model
    XmlListModel
    {
        id: rssmodel
        source: rssmodel_url
        query: "/rss/channel/item"

        XmlRole { name: "model_title"; query: "title/string()" }
        XmlRole { name: "description"; query: "description/string()" }
    }
}
