/*
  license GPL v3 ...........

  description of this file:
  a delegate for the ListView in the RssFeedDelegate, each delegate shows an item of a rss feed ;

  Architecture:
  Item
  {
    Column
    {
        UbuntuShape(for item title)
        {
            Label(title)
        }

        UbuntuShape(for item description)
        {
            Label(description)
        }
    }
  }
*/

import QtQuick 2.0
import Ubuntu.Components 0.1
import Ubuntu.Components.ListItems 0.1 as ListItem

Item {
    id: rss_item_delegate
//    width: 100
//    height: 62

    property string rss_title: ""
    property string rss_description: ""

    signal click()

    Column
    {
        spacing: units.gu(1)
        anchors.fill: parent

        /////////////////////////////////////////////////////            item for title
        UbuntuShape
        {
            id: item_title
            height: label_title.paintedHeight + units.gu(1)
            width: rss_item_delegate.width
            color: "orange"

            Label
            {
                id: label_title
                text: rss_title
                anchors.horizontalCenter: parent.horizontalCenter
                width: parent.width - units.gu(1)
                wrapMode: Text.WrapAtWordBoundaryOrAnywhere
                color: "black"
            }
        }

        /////////////////////////////////////////////////////            item for description
        UbuntuShape
        {
            id: item_description
            height: rss_item_delegate.height - item_title.height - units.gu(1)
            width: rss_item_delegate.width
            color: "lightblue"

//            TextArea
//            {
//                id: textarea_description
//                anchors.horizontalCenter: parent.horizontalCenter
//                width: parent.width/* - units.gu(1)*/
//                height: parent.height
//                text: rss_description
//                selectByMouse: false
//                activeFocusOnPress: false
//                contentWidth: parent.width
//                readOnly: true
//            }
            Label
            {
                id: textarea_description
                anchors.horizontalCenter: parent.horizontalCenter
                width: parent.width - units.gu(1)
                height: parent.height
                text: rss_description
                wrapMode: Text.WrapAtWordBoundaryOrAnywhere
                elide: Text.ElideRight
            }
        }
    }

//    MouseArea
//    {
//        anchors.fill: parent
//        onClicked:
//        {
//            click();
//        }
//    }
}
