import QtQuick 2.0
import Ubuntu.Components 0.1

import "databasemodule.js" as DB
import "tabshelper.js" as TabsHelper

Page {
    id: todayPage
    visible: false
    property bool firstRefresh: true

    signal requestFeedListPage

    function refresh() {
        if(firstRefresh) {
            todayTabs.destroy()
            firstRefresh = false
        }
        var tabsString = "import QtQuick 2.0; import Ubuntu.Components 0.1; Tabs {id: todayTabs; anchors.fill: parent;"
        var feeds = DB.loadFeeds()
        if(feeds.length > 0) {
            for(var i = 0; i < feeds.length; i++) {
                var feed = feeds[i];
                console.log("displayName: " + feed.displayName)
                //            ourTabs.__tabsModel.children[i].title = feed.displayName
                //            ourTabs.__tabsModel.children[i].entryListPage.loadEntriesByUrl(feed.link)
                tabsString += "EntryListTab {"
                tabsString += "title: \"" + feed.displayName + "\";"
                tabsString += "feedLink: \"" + feed.link + "\";"
                tabsString += "}"
            }
            noFeedsHint.text = ""
        } else {
            var labelText  = i18n.tr("No feeds added.Click the feed icon in the toolbar to get started.")
            //tabsString += "Tab { title: \"No feeds\"; page: Page { anchors.fill: parent; Label { anchors.centerIn: parent; wrapMode: Text.WordWrap; width: parent.width - units.gu(15); horizontalAlignment: Text.AlignHCenter; text: \"" + labelText + "\"; } } }"
            tabsString += "Tab { title: \"No feeds\" }" //
            noFeedsHint.text = labelText
        }
        tabsString += "}"; // END Tabs component

        console.log(tabsString)
        console.log(TabsHelper.tabsObject)
        if(TabsHelper.tabsObject !== null) {
            TabsHelper.tabsObject.destroy()
        }

        TabsHelper.tabsObject = Qt.createQmlObject(tabsString,
                                                   todayPage, "todayTabs")
    }

    tools: ToolbarActions {
        Action {
            id: sampleAction

            iconSource: Qt.resolvedUrl("avatar.png")
            text: i18n.tr("Feeds")

            onTriggered: {
                //                mainPageStack.push(feedListPage)
                requestFeedListPage()
            }

        }

        //        back: Action {
        //            onTriggered: {
        //                console.log("Back triggered!")
        //            }
        //        }
    }

    Tabs {
        id: todayTabs
        anchors.fill: parent

        Tab {

        }
    }

    Label {
        id: noFeedsHint

        anchors.centerIn: parent;
        wrapMode: Text.WordWrap;
        width: parent.width - units.gu(15);
        horizontalAlignment: Text.AlignHCenter;
    }
}
