# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
# Copyright 2013 Canonical
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.

"""RSS Reader app autopilot emulators."""


class MainWindow(object):
    """An emulator class that makes it easy to interact with the
    rssreader-app.

    """
    def __init__(self, app):
        self.app = app

    def get_new_event_name_input_box(self):
        return self.app.select_single("TextField", objectName="newFeedUrl")

    def get_confirm_button(self):
        return self.app.select_single('Button', text='confirm')

    def get_list_all_news(self):
        return self.app.select_single('Subtitled', text='All news')

    def get_feeds(self):
        return self.app.select_many('Subtitled', objectName="feedItem")

    def get_individual_feed(self, feedName):
        return self.app.select_single('Subtitled', text=feedName)

    def get_canonical_feed(self):
        return self.app.select_single('Subtitled', text='Canonical')
        #feeds = self.get_feeds()
        #for feed in feeds:
        #    if feed.text == "Canonical":
        #        return feed
        #return None

    def get_update_feed_context_menu_item(self):
        return self.app.select_single("Empty", text="Update")

    def get_remove_form_popOver(self):
        return self.app.select_single("Empty", text="Remove")
